/*

Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.

*/

// thanks to Apple for this really cool code so I haven't had to spend hours creating it myself. I love you Apple!

var gSources = new Array();
gSources["Monophonic"] = { label: "Monophonics Top 10", src: "http://www.sonnerie.net/external/DrtTop/get.top.php", args: "a=widget&vc=1&vl=10&l_ca=333366&l_ch=333366&r_c=333366&f_c=FFCC99&t=2&d=0&s=0&r=1&r_cont=1&la=EN&b=0&l_sth=underline&i_b=1&h=1&p_a=0&c_t=x&t_wi=100%&t_he=100%" };
gSources["Polyphonic"] = { label: "Polyphonics Top 10", src: "http://www.sonnerie.net/external/DrtTop/get.top.php", args: "a=widget&vc=1&vl=10&l_ca=333366&l_ch=333366&r_c=333366&f_c=FFCC99&t=14&d=0&s=0&r=1&r_cont=1&la=EN&b=0&l_sth=underline&i_b=1&h=1&p_a=0&c_t=x&t_wi=100%&t_he=100%" };
gSources["Wallpapers"] = { label: "Wallpapers Top 5", src: "http://www.sonnerie.net/external/DrtTop/get.top.php", args: "a=widget&vc=1&vl=5&l_ca=333366&l_ch=333366&r_c=333366&f_c=FFCC99&t=3&d=0&s=0&r=1&r_cont=1&la=EN&b=0&l_sth=underline&i_b=1&h=1&p_a=0&c_t=x&t_wi=100%&t_he=100%" };

// The specifics...

var gRequest = null;
function load_topten(pTopTenID) {
	var vListArea = document.getElementById("topten_list");
	if(vListArea != null) {
		vListArea.innerHTML = "";
		calculateAndShowThumb(vListArea);
		scrollBy(currentContentHeight);
		if(gSources[pTopTenID] != null) {
			var vTopTenName = document.getElementById("topten_name");
			if(vTopTenName != null) {
				vTopTenName.innerText = gSources[pTopTenID].label;
			}
			if(window.widget) widget.setPreferenceForKey(pTopTenID,"Selection");
			kProgressIndicator.start();
			
			gRequest = new XMLHttpRequest();
			gRequest.onreadystatechange = checkRequestResponse;
			gRequest.open("GET",gSources[pTopTenID].src + "?" + gSources[pTopTenID].args,true);
			gRequest.setRequestHeader("Cache-Control", "no-cache");
			gRequest.send();
		}
	}
}
function checkRequestResponse() {
	if (gRequest.readyState == 4) { processRequestResponse(gRequest.responseText); }
}
function processRequestResponse(pResponseText) {
	if((pResponseText == null) || (pResponseText == "")) {
		comms_error("No response from server");
		return;
	}
	var vListArea = document.getElementById("topten_list");
	if(vListArea != null) {
		pResponseText = pResponseText.replace(/[\n\f\r]/gim, " ");
		var vCallURL = null;
		var vTableContent = pResponseText.match(/<table[^>]+>(.*)<\/table>/i);
		if(vTableContent == null) comms_error();
		else {
			var vLinks = vTableContent[1].match(/<a\s+[^>]+>.*?<\/a>/gi);
			if(vLinks == null) comms_error();
			else {
				try {
					var vContent = "<ol>\n";
					for(var vLoop = 0; vLoop < vLinks.length; vLoop++) {
						//var vInfos = vLinks[vLoop].match(/<a.*href\s*=\s*"javascript\:([^\(]+)\(([^\)]+)\)"[^>]*>(.*?)<\/a>/i);
						var vInfos = vLinks[vLoop].match(/<a.*href\s*=\s*"javascript\:([^\(]+)\((.+)\)"[^>]*>(.*?)<\/a>/i);
						if(vInfos) {
						vCallURL = new UrlBuilder(pResponseText, vInfos);
						vContent += "<li><a href=\"" + vCallURL.expandedURL(vInfos) + "\" onclick='if(window.widget) widget.openURL(this.href); return false;'>" + vInfos[3] + "</a></li>\n";
						}
					}
					vContent += "</ol>\n";
					vListArea.innerHTML = vContent;
				} catch(vError) { comms_error(); return; }
			}
		}
		
		calculateAndShowThumb(vListArea);
		scrollBy(currentContentHeight);
	}
	kProgressIndicator.stop();
}
function comms_error(pMessage) {
	if(pMessage == null) pMessage = "Sorry! An error occured while talking to the server. Please try again.";
	alert(pMessage);
	var vObject = document.getElementById("topten_list");
	if(vObject != null) {
		vObject.innerHTML = pMessage;
		calculateAndShowThumb(vObject);
		scrollBy(currentContentHeight);
	}
	kProgressIndicator.stop();
}
function UrlBuilder(pResponseText, pInfos) {
	this.arguments = new Array();
	this.arguments["id"] = "";
	this.arguments["name"] = "";
	this.arguments["src"] = "";
	this.encoded_url = "";
	if(pInfos[1] == "jsOpenhWnd") {
		var vREMatch = pInfos[2].match(/'(http:\/\/[^\?]+\?.*id\s*=\s*([^&]*).*son_nom\s*=\s*([^&]*).*(?:logo_image|son_wav)\s*=\s*([^&]*).*)'/i);
		if(vREMatch != null) {
			this.encoded_url = vREMatch[1];
			this.arguments["id"] = vREMatch[2];
			this.arguments["name"] = vREMatch[3];
			this.arguments["src"] = vREMatch[4];
		}
	} else {
		var vScripts = pResponseText.match(/<script[^>]*>.*?<\/script>/gi);
		if(vScripts != null) {
			for(var vLoop = 1; vLoop < vScripts.length; vLoop++) {
				var vRegEx = new RegExp("function\\s+" + pInfos[1] + "\\s*\\(([^,]+)\\s*,\\s*([^,]+)\\s*,\\s*([^,]+)\\)\\s*\\{.*?window\\.open\\('(.+)'\\s*,[^\\)]*\\).*?\\}", "i");
				var vDeclaration = vScripts[vLoop].match(vRegEx);
				if(vDeclaration != null) {
					this.encoded_url = vDeclaration[(vDeclaration.length - 1)];
					this.arguments["id"] = "'\\s*\\+\\s*" + vDeclaration[1] + "\\s*\\+\\s*'";
					this.arguments["name"] = "'\\s*\\+\\s*" + vDeclaration[2] + "\\s*\\+\\s*'";
					this.arguments["src"] = "'\\s*\\+\\s*" + vDeclaration[3] + "\\s*\\+\\s*'";
					break;
				}
			}
		}
	}
	for(var vToken in this.arguments) {
		var vRegEx = new RegExp(this.arguments[vToken], "i");
		this.encoded_url = this.encoded_url.replace(vRegEx, "$" + vToken);
	}
	this.expandedURL = function(pInfos) {
		var vResult = this.encoded_url;
		if(pInfos[1] == "jsOpenhWnd") {
			var vREMatch = pInfos[2].match(/'(http:\/\/[^\/]+\?.*id\s*=\s*([^&]*).*son_nom\s*=\s*([^&]*).*(?:logo_image|son_wav)\s*=\s*([^&]*).*)'/i);
			if(vREMatch != null) {
				this.arguments["id"] = vREMatch[2];
				this.arguments["name"] = vREMatch[3];
				this.arguments["src"] = vREMatch[4];
			}
		} else {
			var vREMatch = pInfos[2].match(/(\d+)\s*,\s*'([^,]+)'\s*,\s*'([^,]+)'/i);
			if(vREMatch != null) {
				this.arguments["id"] = vREMatch[1];
				this.arguments["name"] = vREMatch[2];
				this.arguments["src"] = vREMatch[3];
			}
		}
		for(var vToken in this.arguments) {
			var vRegEx = new RegExp("\\$" + vToken, "i");
			vResult = vResult.replace(vRegEx, this.arguments[vToken].replace(/\\'/g, "\\'"));

		}
		return vResult;
	};
}
function query_source_changed() {
	var vPopUp = document.getElementById("query_src_popup");
	var vLabel = document.getElementById("query_src");
	if((vPopUp != null) && (vLabel != null)) {
		vLabel.innerText = "Look for " + vPopUp.options[vPopUp.selectedIndex].text;
	}
}
function do_query(pQueryString) {
	if(pQueryString != "") {
		var vPopUp = document.getElementById("query_src_popup");
		if(vPopUp != null) {
			var vURL = (vPopUp.value + "?k=" + encodeURI(pQueryString.replace(/\s+/, "+")));
			if(window.widget) widget.openURL(vURL);
			else window.location = vURL;
		}
	}
}
function widget_vcheck_dismiss_callback() {
	calculateAndShowThumb(document.getElementById("topten_list"));
	scrollBy(currentContentHeight);
	kProgressIndicator.stop();
}


// Setting-up, dealing with prefs and flipping, etc..
var kProgressIndicator;

function setup() {
	widget_vcheck_textdb("http://www.widgetizer.com/update.txt", "update_link", "id\\|version", ["page"]);
	
	scrollerInit(document.getElementById("scrollbar"), document.getElementById("scrollbar_track"), document.getElementById("scrollbar_thumb"));
	kProgressIndicator = new ProgressIndicator(document.getElementById("progression_wheel"), "Images/prog", document.getElementById("flight_on_time"));
	
	if(window.widget) {
		// The preferences are retrieved:
		var vLastSource = widget.preferenceForKey("Selection");
		
		var vPopUp = document.getElementById("topten_popup");
		if(gSources[vLastSource] != null) {
			select_popup_element_by_value(vPopUp, vLastSource); // select the source in the pop-up
		} else {
			vPopUp.selectedIndex = 0; // select the FIRST source in the pop-up
		}
		load_topten(vPopUp.value); // load the list
		
		query_source_changed();
	}
}
function onHide () {
	clearTimer();
}
function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}
function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}

// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)
var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event) {
	if (!flipShown) {
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}
function mouseexit (event) {
	if (flipShown) {
		// fade in the flip widget
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}
function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c) { return a < b ? b : (a > c ? c : a); }
function computeNextFloat (from, to, ease) { return from + (to - from) * ease; }
function enterflip(event) { document.getElementById('fliprollie').style.display = 'block'; }
function exitflip(event) { document.getElementById('fliprollie').style.display = 'none'; }

/******** Progress Indicator *********/

function ProgressIndicator(element, imageBaseURL, ghostElement) {
	this.count = 0;
	this.timer = null;
	this.element = element;
	this.element.style.display = "none";
	this.imageBaseURL = imageBaseURL;
	this.ghostElement = ghostElement;
}

ProgressIndicator.prototype = {
	start : function () {
		if(this.ghostElement) this.ghostElement.style.opacity = 0.5;
		this.element.style.display = "block";
		if (this.timer) clearInterval(this.timer);
		this.tick();
		var localThis = this;
		this.timer = setInterval(function() { localThis.tick() }, 60);
	},

	stop : function () {
		clearInterval(this.timer);
		this.element.style.display = "none";
		if(this.ghostElement) this.ghostElement.style.opacity = 1.0;
	},

	tick : function () {
		var imageURL = this.imageBaseURL + (this.count + 1) + ".png";
		this.element.src = imageURL;
		this.count = (this.count + 1) % 12;
	}
}

function select_popup_element_by_value(pPopUp, pValue) {
	try {
		for(var vLoop = 0; vLoop < pPopUp.options.length; vLoop++) {
			if(pPopUp.options[vLoop].value == pValue) {
				pPopUp.selectedIndex = vLoop;
				break;
			}
		}
	} catch(vError) { pPopUp.selectedIndex = 0; }
}